const _ = require('lodash')
const jsYaml = require('js-yaml')
const Config = require('../../Config')
//
//
//
const MoodleGradingManager = require('./MoodleGradingManager')
const MoodleCommentManager = require('./MoodleCommentManager')
const AssessmentManager = require('./AssessmentManager')
//
//
//

class specificContentScript{
  //

  init (callback) {
    window.abwa.specific = window.abwa.specific || {}
    //
    //
    //
    // Enable different functionality if current user is the teacher or student
    this.currentUserIsTeacher((err, isTeacher) => {
      if (err) {
        if (_.isFunction(callback)) {
          callback(err)
        }
      } else {
        if (isTeacher) { // Open modes
          window.abwa.specific = window.abwa.specific || {}
  
          window.abwa.specific.moodleGradingManager = new MoodleGradingManager()
          window.abwa.specific.moodleGradingManager.init()
  
          window.abwa.specific.assessmentManager = new AssessmentManager({
            cmid: window.abwa.rubricManager.rubric.cmid
          })
          window.abwa.specific.assessmentManager.init()
          //
        } else { // Change to viewing mode
          window.abwa.specific = window.abwa.specific || {}
          window.abwa.tagManager.showViewingTagsContainer()
          window.abwa.sidebar.openSidebar()
          // Toolset hide
          window.abwa.toolset.hide()
          // Log student reviewed the exam
          // window.abwa.specific.studentLogging = new StudentLogging()
          // window.abwa.specific.studentLogging.init()
          if (_.isFunction(callback)) {
            callback()
          }
        }
        //
      }
    })
  }

  //
  currentUserIsTeacher (callback) {
    window.abwa.hypothesisClientManager.hypothesisClient.searchAnnotations({
      url: window.abwa.groupSelector.currentGroup.url,
      order: 'desc',
      tags: Config.exams.namespace + ':' + Config.exams.tags.statics.teacher
    }, (err, annotations) => {
      if (err) {
        if (_.isFunction(callback)) {
          callback(err)
        }
      } else {
        if (annotations.length > 0) {
          let params = jsYaml.load(annotations[0].text)
          callback(null, params.teacherId === window.abwa.groupSelector.user.userid) // Return if current user is teacher
        } else {
          if (_.isFunction(callback)) {
            callback(null)
          }
        }
      }
    })
  }
  //

  destroy(){
    //
    try {
      if (window.abwa.specific) {
        if (window.abwa.specific.moodleGradingManager) {
          window.abwa.specific.moodleGradingManager.destroy()
        }
      }
    } catch (e) {
      // TODO Show user need to reload the page?
    }
    //
  }
}

module.exports = specificContentScript
  }
}

module.exports = specificContentScript